/* 
 * Copyright (c) 2018 Samsung Electronics Co., Ltd. All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef LOTTIELOADER_H
#define LOTTIELOADER_H

#include<sstream>
#include<memory>
#include<vector>

#include "rlottie.h"

class LOTModel;
class LottieLoader
{
public:
   static void configureModelCacheSize(size_t cacheSize);
   bool load(const std::string &filePath, bool cachePolicy);
   bool loadFromData(std::string &&jsonData, const std::string &key,
                     const std::string &resourcePath, bool cachePolicy,
                     const std::vector<std::pair<std::uint32_t, std::uint32_t>>
                         &colorReplacements, rlottie::FitzModifier fitzModifier);
   std::shared_ptr<LOTModel> model();
private:  
   std::shared_ptr<LOTModel>    mModel;
};

#endif // LOTTIELOADER_H


